﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Data;
using System.Windows.Interactivity;
using Infragistics.Controls.Editors;
using System.Collections;
using Infragistics.Windows.DataPresenter;
using System.Windows.Forms;
using Infragistics.Windows.Editors;

namespace WpfApplication7
{
    public class XamdataGridBehaviour : Behavior<XamDataGrid>
    {
        protected override void OnAttached()
        {

        }
        public static DependencyProperty AddRowProperty = DependencyProperty.Register("AddRowFlag", typeof(bool), typeof(XamdataGridBehaviour), new FrameworkPropertyMetadata(false, FrameworkPropertyMetadataOptions.BindsTwoWayByDefault, AddNewRow));
        public bool AddRowFlag
        {
            get { return (bool)GetValue(AddRowProperty); }
            set { SetValue(AddRowProperty, value); }
        }

        public static DependencyProperty WorkBookListProperty = DependencyProperty.Register("WorkBookList", typeof(ObservableCollection<string>), typeof(XamdataGridBehaviour), new FrameworkPropertyMetadata());
        public ObservableCollection<string> WorkBookList
        {
            get { return (ObservableCollection<string>)GetValue(WorkBookListProperty); }
            set { SetValue(WorkBookListProperty, value); }
        }
        private static void AddNewRow(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            if (!(bool)e.NewValue) return;
            XamdataGridBehaviour xamDataGridBehaviourobj = (XamdataGridBehaviour)d;
            TemplateField obj = (TemplateField)xamDataGridBehaviourobj.AssociatedObject.FieldLayouts[0].Fields[0];
            ObservableCollection<string> s1 = xamDataGridBehaviourobj.WorkBookList;
            obj.EditTemplate = CreateEditorTemplate1("Workbook", xamDataGridBehaviourobj);
            //TemplateField obj1 = (TemplateField)xamDataGridBehaviourobj.AssociatedObject.FieldLayouts[0].Fields[2];
            //obj1.EditTemplate = CreateEditorTemplate2(obj1.EditTemplate.DataTemplateKey);
            xamDataGridBehaviourobj.AddRowFlag = false;
        }

        private static DataTemplate CreateEditorTemplate1(string columnKey, XamdataGridBehaviour xamDataGridBehaviourobj)
        {
            try
            {
                DataTemplate editorTemplate = new DataTemplate();
                FrameworkElementFactory comboEditor = new FrameworkElementFactory(typeof(XamComboEditor));
                ObservableCollection<string> workBookList = new ObservableCollection<string>();

                foreach (var WorkBookName in xamDataGridBehaviourobj.WorkBookList)
                {
                    workBookList.Add(WorkBookName);
                }
                comboEditor.SetBinding(XamComboEditor.ItemsSourceProperty, new System.Windows.Data.Binding() { Mode = BindingMode.Default, Source = workBookList });
                comboEditor.SetBinding(XamComboEditor.SelectedItemProperty, new System.Windows.Data.Binding(columnKey) { Mode = BindingMode.TwoWay });
                editorTemplate.VisualTree = comboEditor;
                return editorTemplate;
            }
            catch (Exception)
            {
                throw;
            }
        }

        //private static DataTemplate CreateEditorTemplate2(object templateKey)
        //{
        //    try
        //    {
        //        DataTemplate editorTemplate = new DataTemplate();
        //        editorTemplate.DataType = typeof(string);
        //        FrameworkElementFactory comboEditor = new FrameworkElementFactory(typeof(XamComboEditor));
        //        ObservableCollection<String> obj = new ObservableCollection<string>();
        //        obj.Add("Include");
        //        obj.Add("Exclude");
        //        comboEditor.SetBinding(XamComboEditor.ItemsSourceProperty, new System.Windows.Data.Binding() { Mode = BindingMode.Default, Source = obj });
        //        editorTemplate.VisualTree = comboEditor;
        //        editorTemplate.Seal();
        //        return editorTemplate;
        //    }
        //    catch (Exception)
        //    {
        //        throw;
        //    }
        //}
    }
}
